//http://upload.wikimedia.org/wikipedia/commons/3/3d/Timezones_optimized.png
//http://www.worldtimezone.com/daylight.htm
var tzinfo = new Array();
// chaque ville contient 4 donnes spares par des 
// le premier : - si le dcalage est avant greenwich, + s'il est sur ou aprs greenwich
// le deuxime : le nombre d'heures de dcalage (sans les minutes)
// le troisime : le nombre de minutes de dcalage si applicable, sinon 0
// le quatrime : 1 si le day saving time est pris en compte, sinon 0
tzinfo['Afrique'] = new Array();
tzinfo['Afrique']['Afrique du Sud'] = new Array();
tzinfo['Afrique']['Afrique du Sud']['Le Cap'] = '+200';

tzinfo['Amrique'] = new Array();
tzinfo['Amrique']['Argentine'] = new Array();
tzinfo['Amrique']['Argentine']['Buenos Aires'] = '-300';
tzinfo['Amrique']['Canada'] = new Array();
tzinfo['Amrique']['Canada']['Calgary'] = '-701';
tzinfo['Amrique']['Canada']['Edmonton'] = '-701';
tzinfo['Amrique']['Canada']['Montral'] = '-501';
tzinfo['Amrique']['Canada']['Qubec'] = '-501';
tzinfo['Amrique']['Canada']['Toronto'] = '-501';
tzinfo['Amrique']['Canada']['Vancouver'] = '-801';
tzinfo['Amrique']['Canada']['Winnipeg'] = '-601';
tzinfo['Amrique']['tats-Unis'] = new Array();
tzinfo['Amrique']['tats-Unis']['Chicago'] = '-601';
tzinfo['Amrique']['tats-Unis']['Dallas'] = '-601';
tzinfo['Amrique']['tats-Unis']['Denver'] = '-701';
tzinfo['Amrique']['tats-Unis']['Los Angeles'] = '-801';
tzinfo['Amrique']['tats-Unis']['New York'] = '-501';
tzinfo['Amrique']['Mexique'] = new Array();
tzinfo['Amrique']['Mexique']['Mexico'] = '-601';

tzinfo['Asie'] = new Array();
tzinfo['Asie']['Chine'] = new Array();
tzinfo['Asie']['Chine']['Beijing'] = '+800';
tzinfo['Asie']['Chine']['Shanghai'] = '+800';
tzinfo['Asie']['Inde'] = new Array();
tzinfo['Asie']['Inde']['Bombay'] = '+5300';
tzinfo['Asie']['Japon'] = new Array();
tzinfo['Asie']['Japon']['Tokyo'] = '+900';


tzinfo['Europe'] = new Array();
tzinfo['Europe']['Angleterre'] = new Array();
tzinfo['Europe']['Angleterre']['Londres'] = '+001';
tzinfo['Europe']['Belgique'] = new Array();
tzinfo['Europe']['Belgique']['Bruxelles'] = '+101';
tzinfo['Europe']['France'] = new Array();
tzinfo['Europe']['France']['Paris'] = '+101';
tzinfo['Europe']['Russie'] = new Array();
tzinfo['Europe']['Russie']['Moscou'] = '+301';

tzinfo['Ocanie'] = new Array();
tzinfo['Ocanie']['Australie'] = new Array();
tzinfo['Ocanie']['Australie']['Sydney'] = '+1001';

var time_digit = new Array();
time_digit[0] = 'EuropeFranceParis';
time_digit[1] = 'Amriquetats-UnisNew York';
time_digit[2] = 'EuropeRussieMoscou';
time_digit[3] = 'OcanieAustralieSydney';
time_digit[4] = 'AsieIndeBombay';
time_digit[5] = 'AfriqueAfrique du SudLe Cap';
time_digit[6] = 'AmriqueMexiqueMexico';

var labels_fuseau = new Array();
//continentpaysvillelefttop
labels_fuseau[0] = 'Amriquetats-UnisLos Angeles5590';
labels_fuseau[1] = 'AmriqueMexiqueMexico79129';
labels_fuseau[2] = 'Amriquetats-UnisNew York14280';
labels_fuseau[3] = 'EuropeFranceParis27869';
labels_fuseau[4] = 'EuropeRussieMoscou33051';
labels_fuseau[5] = 'AfriqueAfrique du SudLe Cap307255';
labels_fuseau[6] = 'AsieJaponTokyo52887';
//'Djakarta 490 200
//'Le Caire 334 116
//'Melbourne 534 282

function getDecalageForLocation(tz)
{
    var info = tz.split('');
    if(info.length != 4) return 0;

    // decalage de l'heure par rapport a l'heure GMT
    var coef = (info[0] == '-') ? -1 : 1;
    var decalage = coef * parseInt(info[1]) * 60 + coef * parseInt(info[2]);

    // heure d't si applicable
    if(is_dst == 1 && info[3] == '1')
    {
        decalage += 60;
    }

    return decalage;
}

function getTimeForLocation(tz)
{
    var info = tz.split('');
    if(info.length != 4) return '00h00';

    // decalage de l'heure par rapport a l'heure GMT
    var coef = (info[0] == '-') ? -1 : 1;
    var h = gmt_time[0] + coef * parseInt(info[1]);
    var m = gmt_time[1] + coef * parseInt(info[2]);

    // heure d't si applicable
    if(is_dst == 1 && info[3] == '1')
    {
        h++;
    }

    // ajustement aux minutes
    if(m < 0)
    {
        m += 60;
        h--;
    }
    else if(m > 59)
    {
        m -= 60;
        h++;
    }

    // ajustement aux heures
    if(h < 0)
    {
        h += 24;
    }
    else if(h > 23)
    {
        h -= 24;
    }

    var new_time = '';
    if(h < 10) new_time += '0';
    new_time += h.toString()+'h';
    if(m < 10) new_time += '0';
    new_time += m.toString();
    return new_time;
}

function updateClocks()
{
    var loc, t, img, pos;
    for(key in time_digit)
    {
        loc = time_digit[key].split('');
        if(loc.length == 3 && tzinfo[loc[0]][loc[1]][loc[2]])
        {
            t = getTimeForLocation(tzinfo[loc[0]][loc[1]][loc[2]]);
            for(var i = 0; i < t.length; ++i)
            {
                if(t.charAt(i) != 'h')
                {
                    img = document.getElementById('digit_'+key+'_'+i);
                    if(img && img.src.indexOf(t.charAt(i)+'.gif') == -1)
                    {
                        pos = img.src.indexOf('.gif');
                        img.src = img.src.substr(0,pos-1)+t.charAt(i)+'.gif';
                    }
                }
            }
        }
    }
}

function updateLabelsFuseau()
{
    var parts,label;
    for(i in labels_fuseau)
    {
        label = document.getElementById('label_fuseau'+i);
        if(label)
        {
            parts = labels_fuseau[i].split('');
            if(parts.length == 5 && tzinfo[parts[0]][parts[1]][parts[2]])
            {
                label.innerHTML = '&nbsp;'+getTimeForLocation(tzinfo[parts[0]][parts[1]][parts[2]])+'&nbsp;';
            }
        }
    }
}

function updateGreenwich()
{
    var g = document.getElementById('greenwich');
    var hg = document.getElementById('heuregmt');
    if(!g || !hg) return;
    g.innerHTML = getTimeForLocation('+000');
    hg.innerHTML = getTimeForLocation('+000');
}

function updateLocalTime()
{
    var l = document.getElementById('heurelocale');
    if(!l) return;
    var d = new Date();
    var decalage = d.getTimezoneOffset();
    var str = (decalage > 0) ? '-' : '+';
    l.innerHTML = getTimeForLocation(str + Math.floor(decalage/60) + '' + (decalage % 60) + '0');
}

function updateOrigine()
{
    var f = document.f_diff;
    var str = '';
    if(f.c_origine.value != '' && f.p_origine.value != '' && f.v_origine.value != '')
    {
        str = 'Il est actuellement <b>'+
            getTimeForLocation(tzinfo[f.c_origine.value][f.p_origine.value][f.v_origine.value])+
            '</b>  '+f.v_origine.value;
    }
    document.getElementById('time_origine').innerHTML = str;
    updateDifference();
}

function updateDestination()
{
    var f = document.f_diff;
    var str = '';
    if(f.c_destination.value != '' && f.p_destination.value != '' && f.v_destination.value != '')
    {
        str = 'Il est actuellement <b>'+
            getTimeForLocation(tzinfo[f.c_destination.value][f.p_destination.value][f.v_destination.value])+
            '</b>  '+f.v_destination.value;
    }
    document.getElementById('time_destination').innerHTML = str;
    updateDifference();
}

function updateDifference()
{
    var f = document.f_diff;
    var str = '';
    if(f.c_origine.value != '' && f.p_origine.value != '' && f.v_origine.value != '' &&
       f.c_destination.value != '' && f.p_destination.value != '' && f.v_destination.value != '')
    {
        var difference =
            getDecalageForLocation(tzinfo[f.c_destination.value][f.p_destination.value][f.v_destination.value]) -
            getDecalageForLocation(tzinfo[f.c_origine.value][f.p_origine.value][f.v_origine.value]);
        var h = Math.floor(difference / 60);
        var m;
        difference -= h * 60;
        if(difference < 0)
        {
            difference *= -1;

            if(h == 0)
            {
                h = '-0';
            }
        }

        if(difference >= 0 && difference < 10)
        {
            m = '0'+difference.toString();
        }
        else
        {
            m = difference;
        }

        str = '<font color="0000A1"><b>Il y a donc <span class="arial-18"><font color="#000000">'+h+'h'+m
            +'</font></span> de dcalage horaire entre '+f.v_origine.value+' & '+f.v_destination.value+'</b></font>';
    }
    document.getElementById('time_difference').innerHTML = str;
}

function updateFuseau()
{
    var f = document.getElementById('imgfuseau');
    if(f)
    {
        var debut = f.src.indexOf('images-temps/');
        if(debut == -1) return;
        f.src = f.src.substring(0,debut+13)+gmt_time[0].toString()+'.gif';
    }
}

function updateTimes()
{
    gmt_time[2]++;
    if(gmt_time[2]==60)
    {
        gmt_time[1]++;
        gmt_time[2]=0;
    }
    else
        return;// pas besoin de continuer, ya que les secondes qui ont bouges

    if(gmt_time[1]==60)
    {
        gmt_time[0]++;
        gmt_time[1]=0;
        updateFuseau();
    }
    if(gmt_time[0]==24)
    {
        gmt_time[0]=0;
    }

    updateClocks();
    updateGreenwich();
    updateLocalTime();
    updateOrigine();
    updateDestination();
    updateLabelsFuseau()
}

function updateSelects(obj)
{
    var f = document.f_diff;
    if(obj.name == 'c_origine')
    {
        f.v_origine.selectedIndex = 0;
        f.v_origine.options.length = 1;
        f.p_origine.selectedIndex = 0;
        f.p_origine.options.length = 1;
        if(obj.value != '')
        {
            var opt;
            for(pays in tzinfo[obj.value])
            {
                opt = document.createElement('OPTION');
                opt.value = pays;
                opt.text = pays;
                f.p_origine.options[f.p_origine.options.length] = opt;
            }
        }
        updateOrigine();
    }
    else if(obj.name == 'p_origine')
    {
        f.v_origine.selectedIndex = 0;
        f.v_origine.options.length = 1;
        if(obj.value != '')
        {
            var opt;
            for(ville in tzinfo[f.c_origine.value][obj.value])
            {
                opt = document.createElement('OPTION');
                opt.value = ville;
                opt.text = ville;
                f.v_origine.options[f.v_origine.options.length] = opt;
            }
        }
        updateOrigine();
    }
    else if(obj.name == 'c_destination')
    {
        f.v_destination.selectedIndex = 0;
        f.v_destination.options.length = 1;
        f.p_destination.selectedIndex = 0;
        f.p_destination.options.length = 1;
        if(obj.value != '')
        {
            var opt;
            for(pays in tzinfo[obj.value])
            {
                opt = document.createElement('OPTION');
                opt.value = pays;
                opt.text = pays;
                f.p_destination.options[f.p_destination.options.length] = opt;
            }
        }
        updateDestination();
    }
    else if(obj.name == 'p_destination')
    {
        f.v_destination.selectedIndex = 0;
        f.v_destination.options.length = 1;
        if(obj.value != '')
        {
            var opt;
            for(ville in tzinfo[f.c_destination.value][obj.value])
            {
                opt = document.createElement('OPTION');
                opt.value = ville;
                opt.text = ville;
                f.v_destination.options[f.v_destination.options.length] = opt;
            }
        }
        updateDestination();
    }
}

function loadLabelsFuseau()
{
    var cadre = document.getElementById('cadre_fuseau');
    for(i in labels_fuseau)
    {
        var parts = labels_fuseau[i].split('');
        cadre.innerHTML += '<div class="arial-9-b" style="position:absolute;top:'+parts[4]+'px;left:'+parts[3]+'px;">* '+parts[2]+'<br><span id="label_fuseau'+i+'" class="label_fuseau">&nbsp;00h00&nbsp;</span></div>';
    }
}

function start_timer()
{
    loadLabelsFuseau();
    updateClocks();
    updateGreenwich();
    updateLocalTime();
    updateFuseau();
    updateLabelsFuseau()
    setInterval('updateTimes()', 1000);
}
